<?php

//
// This program is free software; you can redistribute it and/or
// modify it under the terms of the GNU General Public License
// as published by the Free Software Foundation; either version 2
// of the License, or (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.

// $Id: parse_output.php,v 1.2 2002/03/29 17:14:06 bene Exp $
// File: parse_output.php
// Function: convert text output from ipacsum into html-table
//           

function parse_output($input) {
    //global $in_rules, $out_rules;

    $traffic = array();

    $input_ar = explode("\n",$input);
    //print "<pre>";
    //print_r($input_ar);
    //print "</pre>";
    while ($line = each($input_ar)) {
        if (eregi("Host: (.*) / Time created: (.*)$",$line[1], $regs)) {
	    $host = $regs[1];
	    $create_time = $regs[2];
	    continue;
	}
	if (eregi("Data from (.*) to (.*)$", $line[1], $regs)) {
	    $data_from = $regs[1];
	    $data_to = $regs[2];
	    continue;
	}
	if (eregi("^(.*):(.*)$",$line[1],$regs)) {
	    array_push($traffic, array("rule" => trim($regs[1]),
				     "traffic" => trim($regs[2])
				    ));
	}
    }

    $code = <<<EOD
<table border="0" width="100%">
<tr>
    <td>Hostname:</td>
    <td>$host</td>
</tr>
<tr>
    <td>Time created:</td>
    <td>$create_time</td>
</tr>
<tr>
    <td>Start time:</td>
    <td>$data_from</td>
</tr>
<tr>
    <td>End time:</td>
    <td>$data_to</td>
</tr>
</table>
<table border="1" width="90%">
<tr>
    <td align="center" width="50%">Rule</td>
    <td align="center" width="50%">Traffic</td>
</tr>
EOD;
    
    while ($rule = each($traffic)) {
	  //print_r($rule);
	  $code .= <<<EOD

<tr>
    <td>{$rule[1]["rule"]}
    </td>
    <td>{$rule[1]["traffic"]}
    </td>
</tr>
EOD;

      }
    
    $code .= <<<EOD
</table>
EOD;
    

    return $code;

}

## TODO: layout, split into in/out-rules

?>
