<?php
//
// This program is free software; you can redistribute it and/or
// modify it under the terms of the GNU General Public License
// as published by the Free Software Foundation; either version 2
// of the License, or (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.

// $Id: system_functions.php,v 1.2 2002/03/13 17:07:54 bene Exp $

// So that stupid warnings do not appear when we stats files that do not exist.
error_reporting(5);

// Execute a system function.  Do path checking
// return a trim()'d result.
function execute_program ($program, $args)
{
    $path = array( '/bin/', '/sbin/', '/usr/bin', '/usr/sbin', '/usr/local/bin', '/usr/local/sbin');
    $buffer = '';

    while ($this_path = current($path)) {
        if (is_executable("$this_path/$program")) {
            if ($fp = popen("$this_path/$program $args", 'r')) {
                while (!feof($fp)) {
                    $buffer .= fgets($fp, 4096);
                }
                return trim($buffer);
            }
        }
        next($path);
    }
}


// Returns the virtual hostname accessed.
function sys_vhostname ()
{
    if (!($result = getenv('SERVER_NAME'))) {
        $result = 'N.A.';
    }
    return $result;
}


// Returns the Cannonical machine hostname.
function sys_chostname ()
{
    if ($fp = fopen('/proc/sys/kernel/hostname','r')) {
        $result = trim(fgets($fp, 4096));
        fclose($fp);
        $result = gethostbyaddr(gethostbyname($result));
    } else {
        $result = 'N.A.';
    }
    return $result;
}


// Returns the IP address that the request was made on.
function sys_ip_addr ()
{
    if (!($result = getenv('SERVER_ADDR'))) {
        $result = gethostbyname(sys_chostname());
    }
    return $result;
}




?>
